<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\FPA\Entity\FpaeventohEntity;
use HCM\Util\DateUtil;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\Model\Gestaopessoas\Entities\FpaEventoh;
use \Datetime;

class EventoService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->associacao = Repositories::FPA_EVENTOCTBL;
    }
    
     public function salvaAssocEventoOper($dataset) {
        //$this->entityManager->beginTransaction();
        try {
            $eventom = $this->entityManager->getRepository(Repositories::FPA_EVENTOH)->findOneBy(array("nreventoh" => $dataset['NREVENTOH'],"nrorg" => $dataset['NRORG']));
            $eventoctbloper = $this->entityManager->getRepository(Repositories::FPA_EVENTOCTBL)->findOneBy(array("nreventom" => $eventom->getNreventom(), "nrestruturam" => null,"nrorg" => $dataset['NRORG'],"nrtpeventoctbl" => null, "nrtpeventoctbl" => $dataset["NRTPEVENTOCTBLOPER"]));
            $dataset['CDOPERINCLUSAO'] = $dataset['CDOPERINCLUSAO'] ? $dataset['CDOPERINCLUSAO'] : $this->hcmParameters->getCdOperador();
            if(!$eventoctbloper){
                $eventoctbloper = new $this->associacao();
                $codigo = \HCM\Util\NovoCodigo::geraCodigo($dataset['NRORG'], 'FPA_EVENTOCTBL', 1, 12, true);
                $eventoctbloper->setNreventoctbl($codigo);
                $eventoctbloper->setCdoperinclusao($dataset['CDOPERINCLUSAO']);
                $eventoctbloper->setDtinclusao(DateUtil::getDataAtual());
                $eventoctbloper->setDtinivigencia(DateUtil::getDataDeString2($dataset['DTINIVIGENCIA'], "d/m/Y", true));
                $eventoctbloper->setNreventom($eventom->getNreventom());
                $eventoctbloper->setNrorg($dataset['NRORG']);
                $eventoctbloper->setNrorginclusao($dataset['NRORG']);
            }
                $eventoctbloper->setIdvincativo("S");
                $eventoctbloper->setDtultatu(DateUtil::getDataAtual());
                $eventoctbloper->setNrorgultatu($dataset['NRORG']);
                $eventoctbloper->setCdoperultatu($dataset['CDOPERULTATU']?$dataset['CDOPERULTATU']:$dataset['CDOPERINCLUSAO']);
                $eventoctbloper->setCdcontctbldeb(isset($dataset["CDCONTCTBLDEBOPER"])?$dataset["CDCONTCTBLDEBOPER"]:null);
                $eventoctbloper->setCdhistpadrdeb(isset($dataset["CDHISTPADRDEBOPER"])?$dataset["CDHISTPADRDEBOPER"]:null);
                $eventoctbloper->setCdcontctblcre(isset($dataset["CDCONTCTBLCREOPER"])?$dataset["CDCONTCTBLCREOPER"]:null);
                $eventoctbloper->setCdhistpadrcre(isset($dataset["CDHISTPADRCREOPER"])?$dataset["CDHISTPADRCREOPER"]:null);
                $eventoctbloper->setCddespadmfat(isset($dataset["CDDESPADMFATOPER"])?$dataset["CDDESPADMFATOPER"]:null);
                $eventoctbloper->setNrtpeventoctbl($dataset["NRTPEVENTOCTBLOPER"] ? $dataset["NRTPEVENTOCTBLOPER"] : null);
                
            $this->entityManager->persist($eventoctbloper);
            $this->entityManager->flush();
            return $eventoctbloper->getNreventoctbl();
        } catch (\Exception $e) {            
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function salvaAssocEventoAdm($dataset) {
        //$this->entityManager->beginTransaction();
        try {
            $eventom = $this->entityManager->getRepository(Repositories::FPA_EVENTOH)->findOneBy(array("nreventoh" => $dataset['NREVENTOH'],"nrorg" => $dataset['NRORG']));
            $eventoctbladm = $this->entityManager->getRepository(Repositories::FPA_EVENTOCTBL)->findOneBy(array("nreventom" => $eventom->getNreventom(), "nrestruturam" => null,"nrorg" => $dataset['NRORG'],"nrtpeventoctbl" => null, "nrtpeventoctbl" => $dataset["NRTPEVENTOCTBLADM"]));
            $dataset['CDOPERINCLUSAO'] = $dataset['CDOPERINCLUSAO'] ? $dataset['CDOPERINCLUSAO'] : $this->hcmParameters->getCdOperador();
            if(!$eventoctbladm){
                $eventoctbladm = new $this->associacao();
                $codigo = \HCM\Util\NovoCodigo::geraCodigo($dataset['NRORG'], 'FPA_EVENTOCTBL', 1, 12, true);
                $eventoctbladm->setNreventoctbl($codigo);
                $eventoctbladm->setCdoperinclusao($dataset['CDOPERINCLUSAO'] ? $dataset['CDOPERINCLUSAO'] : $this->hcmParameters->getCdOperador());
                $eventoctbladm->setDtinclusao(DateUtil::getDataAtual());
                $eventoctbladm->setDtinivigencia(DateUtil::getDataDeString2($dataset['DTINIVIGENCIA'], "d/m/Y", true));
                $eventoctbladm->setNreventom($eventom->getNreventom());
                $eventoctbladm->setNrorg($dataset['NRORG']);
                $eventoctbladm->setNrorginclusao($dataset['NRORG']);
            }
                $eventoctbladm->setIdvincativo("S");
                $eventoctbladm->setDtultatu(DateUtil::getDataAtual());
                $eventoctbladm->setNrorgultatu($dataset['NRORG']);
                $eventoctbladm->setCdoperultatu($dataset['CDOPERULTATU'])?$dataset['CDOPERULTATU']:$dataset['CDOPERINCLUSAO'];
                $eventoctbladm->setCdcontctbldeb(isset($dataset["CDCONTCTBLDEBADM"])?$dataset["CDCONTCTBLDEBADM"]:null);
                $eventoctbladm->setCdhistpadrdeb(isset($dataset["CDHISTPADRDEBADM"])?$dataset["CDHISTPADRDEBADM"]:null);
                $eventoctbladm->setCdcontctblcre(isset($dataset["CDCONTCTBLCREADM"])?$dataset["CDCONTCTBLCREADM"]:null);
                $eventoctbladm->setCdhistpadrcre(isset($dataset["CDHISTPADRCREADM"])?$dataset["CDHISTPADRCREADM"]:null);
                $eventoctbladm->setCddespadmfat(isset($dataset["CDDESPADMFATADM"])?$dataset["CDDESPADMFATADM"]:null);
                $eventoctbladm->setNrtpeventoctbl($dataset["NRTPEVENTOCTBLADM"] ? $dataset["NRTPEVENTOCTBLADM"] : null);
                
            $this->entityManager->persist($eventoctbladm);
            $this->entityManager->flush();
            return $eventoctbladm->getNreventoctbl();
        } catch (\Exception $e) {            
            $this->entityManager->rollback();
            throw $e;
        }
    }
     
    public function deleteEvento($dataset) {
        try {
            $this->entityManager->beginTransaction();
            $eventoh = $this->entityManager->getRepository(Repositories::FPA_EVENTOH)->findOneBy(array("nreventom" => $dataset['NREVENTOM'], "nreventoh" => $dataset['NREVENTOH'],"nrorg" => $dataset['NRORG']));
            $this->entityManager->remove($eventoh);
            $this->entityManager->flush();
            $eventohh = $this->entityManager->getRepository(Repositories::FPA_EVENTOH)->findOneBy(array("nreventom" => $dataset['NREVENTOM'],"nrorg" => $dataset['NRORG']));
            if(empty($eventohh)) {
                $eventom = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->findOneBy(array("nreventom" => $dataset['NREVENTOM'],"nrorg" => $dataset['NRORG']));
                $this->entityManager->remove($eventom);
                $this->entityManager->flush();
            }
            $this->entityManager->commit();
        } catch (\Exception $e) {            
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
        public function cadAutoEvento($row) {
        try {
            $this->entityManager->beginTransaction();
            $nrorg = $this->hcmParameters->getNrorgTrabalho();
            $nrorgpadrao = intval($this->hcmParameters->getNrorgPadrao());
            $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
            $preparedDateCompetenc = DateUtil::getDatadeString($dtmescompetenc, DateUtil::FORMATO_BRASILEIRO, true);
            foreach($row['NREVENTOM'] as $key=>$nreventom) {
                $nreventoh = $row['NREVENTOH'][$key];
                $obj = $this->entityManager->getRepository(Repositories::FPA_EVENTOH)->findOneBy(array("nreventom" => $nreventom, "nreventoh" => $nreventoh, "nrorg" => array($nrorg, $nrorgpadrao), "dtmescompetenc" => $preparedDateCompetenc));
                if ($obj == null) 
                    $obj = $this->entityManager->getRepository(Repositories::FPA_EVENTOH)->findOneBy(array("nreventom" => $nreventom, "nreventoh" => $nreventoh, "nrorg" => array($nrorg, $nrorgpadrao)));
                if($obj->getDtmescompetenc()->format("d/m/y") == $preparedDateCompetenc->format("d/m/y")) {
                    $obj->setNrnaturubr($row['NRNATURUBR']);
                    $obj->setDtultatu(DateUtil::getDatadeString($this->hcmParameters->getDataAtual()));
                    $obj->setNrorgultatu($nrorg);
                    $obj->setCdoperultatu($this->hcmParameters->getCdOperador());
                    $this->entityManager->persist($obj);
                    $this->entityManager->flush();
                } else {
                    $newobj = clone $obj;
                    $codigo = \HCM\Util\NovoCodigo::geraCodigo($nrorg, 'FPA_EVENTOH', 1, 12, true);    
                    $newobj->setNreventoh($codigo);
                    $newobj->setNrnaturubr($row['NRNATURUBR']);
                    $newobj->setDtinclusao(DateUtil::getDataDeString($this->hcmParameters->getDataAtual()));
                    $newobj->setDtultatu(DateUtil::getDatadeString($this->hcmParameters->getDataAtual()));
                    $newobj->setNrorgultatu($nrorg);
                    $newobj->setNrorginclusao($nrorg);
                    $newobj->setCdoperinclusao($this->hcmParameters->getCdOperador());
                    $newobj->setCdoperultatu($this->hcmParameters->getCdOperador());
                    $newobj->setDtmescompetenc($preparedDateCompetenc);
                    $this->entityManager->persist($newobj);
                    $this->entityManager->flush();
                }

            }
            $this->entityManager->commit();
        } catch (\Exception $e) {            
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function getEventoh($nreventom, $nreventoh){
        return $this->entityManager->getRepository(Repositories::FPA_EVENTOH)->findOneBy(array('nreventom' => $nreventom, 'nreventoh' => $nreventoh, 'nrorg' => $this->hcmParameters->getNrorgTrabalho()));
    }
    
    public function getRegrasEvento($nreventom, $nrorg){
        return $this->entityManager->getRepository(Repositories::FPA_REGRAH)->findOneBy(array('nreventom' => $nreventom, 'nrorg' => $this->hcmParameters->getNrorgTrabalho()));
    }
    
}