<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;

class VerificacaoRepository {

    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * Retorna todas as verificações que possuam o perfil de acesso passado ou que não tenha nenhum perfil de acesso cadastrado
     *
     * @param $nrorg
     * @param $nrorgPadrao
     * @param $nrPerfilAcesso
     * @return mixed
     */
    public function retornaVerificacoesPorNrorgAndNrorgpadraoAndPerfilacesso($nrorg, $nrorgPadrao, $nrPerfilAcesso)
    {
        $where = " e.idativo = 'S'
                   and (e.nrorg = $nrorg or e.nrorg = $nrorgPadrao)
                   and (e.nrverificacao in (select per1.nrverificacao from \Teknisa\Model\Gestaopessoas\Entities\GerPerfilverifica per1
                                           where per1.nrverificacao = e.nrverificacao
                                             and per1.nrperfilacesso = $nrPerfilAcesso
                                             and (per1.nrorg = $nrorg or per1.nrorg = $nrorgPadrao))
                        or
                        not exists (select per2.nrverificacao from \Teknisa\Model\Gestaopessoas\Entities\GerPerfilverifica per2
                                    where per2.nrverificacao = e.nrverificacao
                                    and (per2.nrorg = $nrorg or per2.nrorg = $nrorgPadrao)))";
        $querybuilder = $this->entityManager->createQueryBuilder();
        $querybuilder
            ->select('e')
            ->from(Repositories::GER_VERIFICACAO, 'e')
            ->where($where);
        $result = $querybuilder->getQuery()->getResult();
        return $result;
    }

    public function executaConsulta($consulta, $params)
    {
        $result = $this->connection->fetchAll($consulta, $params);
        return $result;
    }
} 
